//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class OutOfPlaneSite : VirtualSite {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal OutOfPlaneSite(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.OutOfPlaneSite_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(OutOfPlaneSite obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~OutOfPlaneSite() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_OutOfPlaneSite(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public OutOfPlaneSite(int particle1, int particle2, int particle3, double weight12, double weight13, double weightCross) : this(OpenMMSwigPINVOKE.new_OutOfPlaneSite(particle1, particle2, particle3, weight12, weight13, weightCross), true) {
  }

  public double getWeight12() {
    double ret = OpenMMSwigPINVOKE.OutOfPlaneSite_getWeight12(swigCPtr);
    return ret;
  }

  public double getWeight13() {
    double ret = OpenMMSwigPINVOKE.OutOfPlaneSite_getWeight13(swigCPtr);
    return ret;
  }

  public double getWeightCross() {
    double ret = OpenMMSwigPINVOKE.OutOfPlaneSite_getWeightCross(swigCPtr);
    return ret;
  }

}

}
